# Chapter 6. Functions

## 6.1 Function Basics

## 6.2 Argument Passing

???

### 6.2.1 Passing Arguments by Value

### 6.2.2 Passing Arguments by Reference

### 6.2.3 `const` Parameters and Arguments

### 6.2.4 Array Parameters

### 6.2.5 `main`: Handling Command-Line Options

### 6.2.6 Functions with Varying Parameters

## 6.3 Return Types and the return Statement

## 6.4 Overloaded Functions

## 6.5 Features for Specialized Uses
???

### 6.5.1 Default Arguments

### 6.5.2 Inline and `constexpr` Functions

### 6.5.3 Aids for Debugging

## 6.6 Function Matching

???

#### Determining the Candidate and Viable Functions

#### Finding the Best Match, If Any

#### Function Matching with Multiple Parameters

### 6.6.1 Argument Type Conversions

## 6.7 Pointers to Functions

???

#### Using Function Pointers

#### Pointers to Overloaded Functions

#### Function Pointer Parameters

#### Returning a Pointer to Function

#### Use `auto` or `decltype` for Function Pointer Types